Ext.define('DSS.addon.ScreenTypeSelectorSceneMode', {
	extend : 'DSS.component.Base',
	mixins : {
		observable : 'Ext.util.Observable'
	},
	getHeight : function() {
		return this.iDefaultHeight;
	},
	height : '100%',
	grids : {},
	defMacGridRenderer : function(val, metadata, record, colIdx, store, view) {
		var fIsPassive = false;
		if (record.get('passive') != null)
			if (record.get('passive'))
				fIsPassive = true;
		var fHasNext = false;
		if (record.get('next') == true) {
			fHasNext = true;
		}
        var fHasIcon=false;
        if (record.get('icon') != null)
        {
            fHasIcon=true;
        }
		var sReturn = '<table style="height:16px;"><tr>';
		var iColspaceCounter = 3;

		if (fHasIcon)
        {
            iColspaceCounter--;  
            sReturn+='<td><img src="' + record.get('icon') + '" style="margin-right: 5px;"></td>';
        }
		
		if (fIsPassive) {
			sReturn += '<td style="color:#888888;" colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		} else {
			sReturn += '<td colspan="' + iColspaceCounter + '" width="100%">' + record.get('name') + '</td>';
		}
		if (fHasNext) {
			sReturn += '<td>&gt;</td>';
		}
		return sReturn + '</tr></table>';
	},	
	initStores : function() {
		if (Ext.data.StoreManager.lookup('screentype-zones') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-zones',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('screentype-zones').removeAll();
		}
		
		var oArray=dss.staticDataModel.getZoneArray();
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			var oObject={
					_id:oArray[iIndex].ZoneID,
					name:oArray[iIndex].name,
					next:true,
					passive:false,
					icon:null
			};
			Ext.data.StoreManager.lookup('screentype-zones').add(oObject);
		}
	},
	clearGridLevels : function(idsNotToRemove) {
		if (idsNotToRemove == null)
			idsNotToRemove = [];
		for ( var sKey in this.grids)
			if (idsNotToRemove.indexOf(sKey) < 0)
				this.macPanel.remove(this.grids[sKey]);
	},
	constructGridLvlButtonType: function (zoneID,groupID) {
		if (Ext.data.StoreManager.lookup('screentype-buttontype') == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-buttontype',
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
			var oArray=[{
				_id:5,
				name:_('zone pushbutton (+ scene 1-4)'),
				next:false,
				passive:false,
				icon: null
			},{	
			   _id:1,
				name:_('area 1 pushbutton (+ scene 2-4)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:2,
				name:_('area 2 pushbutton (+ scene 2-4)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:3,
				name:_('area 3 pushbutton (+ scene 2-4)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:4,
				name:_('area 4 pushbutton (+ scene 2-4)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:6,
				name:_('zone pushbutton (+ scene 11-14)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:7,
				name:_('zone pushbutton (+ scene 21-24)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:8,
				name:_('zone pushbutton (+ scene 31-34)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:9,
				name:_('zone pushbutton (+ scene 41-44)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:10,
				name:_('area 1 pushbutton (+ scene 12-14)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:11,
				name: _('area 2 pushbutton (+ scene 22-24)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:12,
				name:_('area 3 pushbutton (+ scene 32-34)'),
				next:false,
				passive:false,
				icon: null
			},{
				_id:13,
				name:_('area 4 pushbutton (+ scene 42-44)'),
				next:false,
				passive:false,
				icon: null
			}];
			Ext.data.StoreManager.lookup('screentype-buttontype').add(oArray);
		}	

		this.grids.lvlButtonType = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 230,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('screentype-buttontype'),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvlButtonType.getSelectionModel().store = this.grids.lvlType.store;
		this.grids.lvlButtonType.parent = this;
		this.grids.lvlButtonType.on('itemclick', function(grid, record) {
			this.parent.dssEditor.editControls.sceneNames.updateSceneNames(zoneID,groupID,record.get('_id'));
			
		});
		if (!this.macPanel.contains(this.grids.lvlButtonType, true))
			this.macPanel.add(this.grids.lvlButtonType);
		
	},
	constructGridLvlType : function (zoneID) {
		if (Ext.data.StoreManager.lookup('screentype-type-' + zoneID) == null) {
			Ext.create('Ext.data.Store', {
				storeId : 'screentype-type-' + zoneID,
				fields : [ '_id', 'name', 'next', 'icon', 'passive' ],
				proxy : {
					type : 'memory',
					reader : {
						type : 'json',
						root : 'items'
					}
				}
			});
		} else {
			Ext.data.StoreManager.lookup('screentype-type-' + zoneID).removeAll();
		}
		
		var oArray=dss.staticDataModel.getGroupForZone(parseInt('' + zoneID,10));
		for (var iIndex=0;iIndex<oArray.length;iIndex++) {
			if([1,2,3,4,5,9,10].indexOf(oArray[iIndex].group)>=0) {			
				var oObject={
						_id:oArray[iIndex].group,
						name:oArray[iIndex].name,
						next:true,
						passive:false,
						icon: oArray[iIndex].icon
				};
				Ext.data.StoreManager.lookup('screentype-type-' + zoneID).add(oObject);
			}
		}
		
		
		this.grids.lvlType = Ext.create('Ext.grid.Panel', {
			hideHeaders : true,
			height : this.iDefaultHeight,
			width : 240,
			autoScroll : true,
			viewConfig : {
				stripeRows : true
			},
			selModel : {
				mode : 'SINGLE'
			},
			store : Ext.data.StoreManager.lookup('screentype-type-' + zoneID),
			columns : [ {
				sortable : false,
				hideable : false,
				dataIndex : 'name',
				flex : 1,
				renderer : this.defMacGridRenderer
			} ]
		});
		this.grids.lvlType.getSelectionModel().store = this.grids.lvlType.store;
		this.grids.lvlType.parent = this;
		this.grids.lvlType.on('itemclick', function(grid, record) {
			this.parent.clearGridLevels([ 'lvl1','lvlType' ]);

			var fIsPassive = false;
			if (record.get('passive') != null) {
				if (record.get('passive') == true) {
					this.getSelectionModel().deselect(record);
					fIsPassive = true;
				}
			}
			if (!fIsPassive) {
				if (record.get('next') == true) {
					this.parent.constructGridLvlButtonType(zoneID,record.get('_id'));
					this.parent.dssEditor.editControls.sceneNames.updateSceneNames(zoneID,record.get('_id'),null);
					this.getSelectionModel().deselectAll();
					this.getSelectionModel().select(record);
				}
			}
		});
		if (!this.macPanel.contains(this.grids.lvlType, true))
			this.macPanel.add(this.grids.lvlType);
	},
	constructMacGrids : function() {

		var me = this;

		if (this.grids.lvl1 != null)
			this.clearGridLevels([ 'lvl1' ]);
		else {
			this.grids.lvl1 = Ext.create('Ext.grid.Panel', {
				hideHeaders : true,
				height : this.iDefaultHeight,
				width : 250,
				autoScroll : true,
				viewConfig : {
					stripeRows : true
				},
				selModel : {
					mode : 'SINGLE'
				},
				store : Ext.data.StoreManager.lookup('screentype-zones'),
				columns : [ {
					sortable : false,
					hideable : false,
					dataIndex : 'name',
					flex : 1,
					renderer : this.defMacGridRenderer
				} ]
			});
			this.grids.lvl1.getSelectionModel().store = this.grids.lvl1.store;
			this.grids.lvl1.parent = this;

			this.grids.lvl1.on('itemclick', function(grid, record) {
				this.parent.clearGridLevels([ 'lvl1' ]);
				
				var fIsPassive = false;
				if (record.get('passive') != null) {
					if (record.get('passive') == true) {
						this.getSelectionModel().deselect(record);
						fIsPassive = true;
					}
				}

				if (!fIsPassive) {
					this.parent.dssEditor.editControls.sceneNames.updateSceneNames(record.get('_id'),null,null);
					this.parent.constructGridLvlType(record.get('_id'));
					this.getSelectionModel().deselectAll();
					this.getSelectionModel().select(record);
				}
			});
		}

		if (!this.macPanel.contains(this.grids.lvl1, true))
			this.macPanel.add(this.grids.lvl1);

	},
	constructor : function(config) {
		this.initStores();
		this.iDefaultHeight = 220;
		this.macPanel = Ext.create('Ext.panel.Panel', {
			border : '0',
			autoScroll : true,
			height : this.iDefaultHeight + 2,
			layout : {
				type : 'hbox'
			},
			items : [],// this.grids.lvl1
			scroll : 'horizontal'
		});

		var me = this;	

		Ext.apply(this, {
			items : [ this.macPanel ]
		});
	
		this.callParent(arguments);
	},
	reset : function() {
		this.constructMacGrids();
		this.grids.lvl1.getSelectionModel().deselectAll();
	},
	isValid : function() {
		var fZone=false;
		var fGroup=false;
		var fButton=false;
		var group=-1;
		if (this.grids.lvl1!=null)
			if (this.grids.lvl1.getSelectionModel()!=null)
				if (this.grids.lvl1.getSelectionModel().getSelection()!=null)
					if (this.grids.lvl1.getSelectionModel().getSelection().length==1)
						if (this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id')!=null)
							fZone=true;
		if (this.grids.lvlType!=null)
			if (this.grids.lvlType.getSelectionModel()!=null)
				if (this.grids.lvlType.getSelectionModel().getSelection()!=null)
					if (this.grids.lvlType.getSelectionModel().getSelection().length==1)
						if (this.grids.lvlType.getSelectionModel().getSelection()[0].get('_id')!=null) {
							fGroup=true;
							group=this.grids.lvlType.getSelectionModel().getSelection()[0].get('_id');
						}
		if (group!=8) {
			if (this.grids.lvlButtonType!=null)
				if (this.grids.lvlButtonType.getSelectionModel()!=null)
					if (this.grids.lvlButtonType.getSelectionModel().getSelection()!=null)
						if (this.grids.lvlButtonType.getSelectionModel().getSelection().length==1)
							if (this.grids.lvlButtonType.getSelectionModel().getSelection()[0].get('_id')!=null)
								fButton=true;
		} else {
			fButton=true;
		}
		return (fZone && fGroup && fButton);
	},
	setValue : function(oValue) {
		this.constructMacGrids();
		this.grids.lvl1.getSelectionModel().select(this.grids.lvl1.store.find('_id',oValue.zone,false,false,true),true); 
		this.constructGridLvlType(oValue.zone);
				
		var oGroupIndex=this.grids.lvlType.store.find('_id',oValue.group,false,false,true)
		if (oGroupIndex != -1) {
			this.grids.lvlType.getSelectionModel().select(oGroupIndex,true);			
			this.dssEditor.editControls.sceneNames.updateSceneNames(oValue.zone,oValue.group,null);
			if (oValue.group!=8) {
				this.constructGridLvlButtonType(oValue.zone,oValue.group);
				var buttonIndex=this.grids.lvlButtonType.store.find('_id',oValue.button,false,false,true)
				if (buttonIndex != -1)
					this.grids.lvlButtonType.getSelectionModel().select(buttonIndex,true);
				this.dssEditor.editControls.sceneNames.updateSceneNames(oValue.zone,oValue.group,oValue.button);				
			}
		}
	},
	getValue : function() {
		var zone=null;
		var group=null;
		var button=null;
		if (this.grids.lvl1!=null)
			if (this.grids.lvl1.getSelectionModel()!=null)
				if (this.grids.lvl1.getSelectionModel().getSelection()!=null)
					if (this.grids.lvl1.getSelectionModel().getSelection().length==1)
						if (this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id')!=null)
							zone=this.grids.lvl1.getSelectionModel().getSelection()[0].get('_id');
		if (this.grids.lvlType!=null)
			if (this.grids.lvlType.getSelectionModel()!=null)
				if (this.grids.lvlType.getSelectionModel().getSelection()!=null)
					if (this.grids.lvlType.getSelectionModel().getSelection().length==1)
						if (this.grids.lvlType.getSelectionModel().getSelection()[0].get('_id')!=null)
							group=this.grids.lvlType.getSelectionModel().getSelection()[0].get('_id');
		if (group!=8) {
			if (this.grids.lvlButtonType!=null)
				if (this.grids.lvlButtonType.getSelectionModel()!=null)
					if (this.grids.lvlButtonType.getSelectionModel().getSelection()!=null)
						if (this.grids.lvlButtonType.getSelectionModel().getSelection().length==1)
							if (this.grids.lvlButtonType.getSelectionModel().getSelection()[0].get('_id')!=null)
								button=this.grids.lvlButtonType.getSelectionModel().getSelection()[0].get('_id');
			return ({
				zone:zone,
				group:group,
				button:button
			});
		} else
			return ({
				zone:zone,
				group:group,
				button:15
			});
	}
});
	